// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of molview_messages.dataserver;

/// Match in a text search
class SearchSuggestion {
  /// Full title of this match.
  final String title;

  /// Entity associated to this match
  final String entity;

  /// Key data class
  final String keyClass;

  /// Key value
  final dynamic keyValue;

  /// Constructor
  SearchSuggestion(this.title, this.entity, this.keyClass, this.keyValue);

  /// Construct from PDS.
  factory SearchSuggestion.fromPds(Map<String, dynamic> data) {
    return new SearchSuggestion(data['title'] as String,
        data['entity'] as String, data['keyClass'] as String, data['keyValue']);
  }

  /// Convert to PDS.
  Map<String, dynamic> toPds() {
    return {
      'title': title,
      'entity': entity,
      'keyClass': keyClass,
      'keyValue': pdsFromDynamic(keyValue)
    };
  }
}
